<template>
  <div class="app">
    <cookie-consent
      variant="primary2"
      decline-jump-to-href="https://www.europeandataportal.eu/cookies"
      :matomo-url="matomoURL"
    />
    <vue-progress-bar />
    <div class="site-wrapper">
      <top/>
      <router-view
         class="content"
        :key="$route.fullPath"
      />
      <bottom/>
    </div>
  </div>

</template>

<script>
  /* eslint-disable no-underscore-dangle */
  import 'vue-cookie-accept-decline/dist/vue-cookie-accept-decline.css';
  import CookieConsent from './components/gdpr/CookieConsent';
  import Top from './components/Top';
  import Bottom from './components/Bottom';
  // Import glue-config.js
  import { glueConfig as GLUE_CONFIG } from '../config/user-config';

  export default {
    name: 'app',
    components: {
      CookieConsent,
      top: Top,
      bottom: Bottom,
    },
    metaInfo() {
      return {
        titleTemplate(chunk) {
          return chunk ? `${chunk} - ${this.$t('message.header.european')} ${this.$t('message.header.dataPortal')}` : `${this.$t('message.header.european')} ${this.$t('message.header.dataPortal')}`;
        },
        meta: [
          { name: 'description', vmid: 'description', content: `${this.$t('message.header.european')} ${this.$t('message.header.dataPortal')}` },
          { name: 'keywords', vmid: 'keywords', content: GLUE_CONFIG.keywords },
        ],
        htmlAttrs: {
          lang: this.$i18n.locale,
        },
      };
    },
    data() {
      return {
        tracker: null,
        matomoURL: this.$env.api.matomoUrl,
        lastRoute: null,
      };
    },
    watch: {
      // eslint-disable-next-line no-unused-vars
      $route(to, from) {
        // Help Matomo track new page views.
        // Also gets triggered on initial page load.

        // router-link somehow makes this watcher trigger twice; Once immediately after the click
        // and once after the new view has loaded.
        // This is a workaround to prevent tracking the same route full path twice.
        if (to.fullPath !== this.lastRoute) {
          // Get url
          let protocol = window.location.protocol;
          if (protocol.slice(-1) !== ':') {
            protocol += ':';
          }

          const router = this.$router;
          const hashMode = router.mode === 'hash' ? '/#' : '';
          // eslint-disable-next-line no-undef
          let basePath = router.options.base;
          basePath = basePath.slice(-1) === '/' ? basePath.slice(0, -1) : basePath;

          const url = `${protocol}//${window.location.host}${basePath}${hashMode}${to.fullPath}`;

          window._paq = window._paq || [];
          window._paq.push(['setCustomUrl', url]);
          window._paq.push(['trackPageView']);
          this.lastRoute = to.fullPath;
        }
      },
    },
  };
</script>

<style lang="scss">
// Normalizes default css rules. See: https://github.com/necolas/normalize.css
@import './styles/utils/normalize.css';

* {
  box-sizing: border-box;
}

.site-wrapper header {
  display: initial;
}

.container-fluid {
    max-width: 1340px !important;
}
</style>

<style lang="scss" scoped>

.app {
  background-color: #f3fafe;
}

.site-wrapper {
  border: 0;
  max-width: none;
  box-shadow: none;
  display: initial;

  .content {
    padding: 30px 30px 0 30px;
    margin-top: 15px;
    margin-bottom: 15px;
    background-color: white;
  }
}
</style>
